2018-05-18 02:00:54

by Joel Fernandes

[permalink] [raw]
Subject: [PATCH RFC 0/2] Tests for preemptoff and irqsoff tracers

From: "Joel Fernandes (Google)" <[email protected]>

Hi,
Here is test code and kselftest for testing the preemptoff and irqsoff
tracers. I am posting it separately just for early feedback since its
the first time I'm writing a kselftest.

I am planning to include these tests in the next series posting of
"Centralize and unify usage of preempt/irq tracepoints" [1]

By the way, other than these I have also completed testing with Ingo's
locking API test suite for [1]. I will include these and other results
in the v7 posting of [1].

[1] http://lkml.iu.edu/hypermail/linux/kernel/1805.0/04948.html

Joel Fernandes (Google) (2):
lib: Add module to simulate atomic sections for testing
{preempt,irqs}off tracers
kselftests: ftrace: Add tests for the preemptoff and irqsoff tracers

lib/Kconfig.debug | 9 +++
lib/Makefile | 1 +
lib/test_atomic_sections.c | 80 +++++++++++++++++++
tools/testing/selftests/ftrace/config | 3 +
.../test.d/preemptirq/irqsoff_tracer.tc | 74 +++++++++++++++++
5 files changed, 167 insertions(+)
create mode 100644 lib/test_atomic_sections.c
create mode 100644 tools/testing/selftests/ftrace/test.d/preemptirq/irqsoff_tracer.tc

Cc: Steven Rostedt <[email protected]>
Cc: Peter Zilstra <[email protected]>
Cc: Ingo Molnar <[email protected]>
Cc: Mathieu Desnoyers <[email protected]>
Cc: Tom Zanussi <[email protected]>
Cc: Namhyung Kim <[email protected]>
Cc: Thomas Glexiner <[email protected]>
Cc: Boqun Feng <[email protected]>
Cc: Paul McKenney <[email protected]>
Cc: Masami Hiramatsu <[email protected]>
Cc: Todd Kjos <[email protected]>
Cc: Erick Reyes <[email protected]>
Cc: Julia Cartwright <[email protected]>
Cc: [email protected]
Signed-off-by: Joel Fernandes (Google) <[email protected]>

--
2.17.0.441.gb46fe60e1d-goog



2018-05-18 01:59:50

by Joel Fernandes

[permalink] [raw]
Subject: [PATCH 1/2] lib: Add module to simulate atomic sections for testing {preempt,irqs}off tracers

From: "Joel Fernandes (Google)" <[email protected]>

In this patch we introduce a test module for simulating a long atomic
section in the kernel which the preemptoff or irqsoff tracers can
detect. This module is to be used only for test purposes and is default
disabled.

Following is the expected output (only briefly shown) that can be parsed
to verify that the tracers are working correctly. We will use this from
the kselftests in future patches.

For the preemptoff tracer:

echo preemptoff > /d/tracing/current_tracer
sleep 1
insmod ./test_atomic_sections.ko atomic_mode=preempt atomic_time=500000
sleep 1
bash-4.3# cat /d/tracing/trace
preempt -1066 2...2 0us@: atomic_sect_run <-atomic_sect_run
preempt -1066 2...2 500002us : atomic_sect_run <-atomic_sect_run
preempt -1066 2...2 500004us : tracer_preempt_on <-atomic_sect_run
preempt -1066 2...2 500012us : <stack trace>
=> kthread
=> ret_from_fork

For the irqsoff tracer:

echo irqsoff > /d/tracing/current_tracer
sleep 1
insmod ./test_atomic_sections.ko atomic_mode=irq atomic_time=500000
sleep 1
bash-4.3# cat /d/tracing/trace
irq dis -1069 1d..1 0us@: atomic_sect_run
irq dis -1069 1d..1 500001us : atomic_sect_run
irq dis -1069 1d..1 500002us : tracer_hardirqs_on <-atomic_sect_run
irq dis -1069 1d..1 500005us : <stack trace>
=> ret_from_fork

Co-authored-by: Erick Reyes <[email protected]>
Cc: Steven Rostedt <[email protected]>
Cc: Peter Zilstra <[email protected]>
Cc: Ingo Molnar <[email protected]>
Cc: Mathieu Desnoyers <[email protected]>
Cc: Tom Zanussi <[email protected]>
Cc: Namhyung Kim <[email protected]>
Cc: Thomas Glexiner <[email protected]>
Cc: Boqun Feng <[email protected]>
Cc: Paul McKenney <[email protected]>
Cc: Masami Hiramatsu <[email protected]>
Cc: Todd Kjos <[email protected]>
Cc: Erick Reyes <[email protected]>
Cc: Julia Cartwright <[email protected]>
Cc: [email protected]
Signed-off-by: Joel Fernandes (Google) <[email protected]>
---
lib/Kconfig.debug | 9 +++++
lib/Makefile | 1 +
lib/test_atomic_sections.c | 80 ++++++++++++++++++++++++++++++++++++++
3 files changed, 90 insertions(+)
create mode 100644 lib/test_atomic_sections.c

diff --git a/lib/Kconfig.debug b/lib/Kconfig.debug
index c40c7b734cd1..4bb865a1f430 100644
--- a/lib/Kconfig.debug
+++ b/lib/Kconfig.debug
@@ -1933,6 +1933,15 @@ config TEST_KMOD

If unsure, say N.

+config TEST_ATOMIC_SECTIONS
+ tristate "Simulate atomic sections for tracers to detect"
+ default n
+ depends on m
+ help
+ Select this option to build a test module that can help test atomic
+ sections by simulating them with a duration supplied as a module
+ parameter. Preempt disable and irq disable modes can be requested.
+
config TEST_DEBUG_VIRTUAL
tristate "Test CONFIG_DEBUG_VIRTUAL feature"
depends on DEBUG_VIRTUAL
diff --git a/lib/Makefile b/lib/Makefile
index ce20696d5a92..e82cf5445b7b 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -46,6 +46,7 @@ obj-y += string_helpers.o
obj-$(CONFIG_TEST_STRING_HELPERS) += test-string_helpers.o
obj-y += hexdump.o
obj-$(CONFIG_TEST_HEXDUMP) += test_hexdump.o
+obj-$(CONFIG_TEST_ATOMIC_SECTIONS) += test_atomic_sections.o
obj-y += kstrtox.o
obj-$(CONFIG_FIND_BIT_BENCHMARK) += find_bit_benchmark.o
obj-$(CONFIG_TEST_BPF) += test_bpf.o
diff --git a/lib/test_atomic_sections.c b/lib/test_atomic_sections.c
new file mode 100644
index 000000000000..3c8816c333c0
--- /dev/null
+++ b/lib/test_atomic_sections.c
@@ -0,0 +1,80 @@
+/*
+ * Atomic section emulation test module
+ *
+ * Emulates atomic sections by disabling IRQs or preemption
+ * and doing a busy wait for a specified amount of time.
+ * This can be used for testing of different atomic section
+ * tracers such as irqsoff tracers.
+ *
+ * (c) 2018. Google LLC
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/ktime.h>
+#include <linux/irq.h>
+#include <linux/printk.h>
+#include <linux/interrupt.h>
+#include <linux/delay.h>
+#include <linux/string.h>
+#include <linux/kthread.h>
+
+static int atomic_time = 100;
+static char atomic_mode[10] = "irq";
+
+module_param_named(atomic_time, atomic_time, int, S_IRUGO);
+module_param_string(atomic_mode, atomic_mode, 10, S_IRUGO);
+MODULE_PARM_DESC(atomic_time, "Period in microseconds (100 uS default)");
+MODULE_PARM_DESC(atomic_mode, "Mode of the test such as preempt or irq (default irq)");
+
+static void busy_wait(int time)
+{
+ ktime_t start, end;
+ start = ktime_get();
+ do {
+ end = ktime_get();
+ if (kthread_should_stop())
+ break;
+ } while (ktime_to_ns(ktime_sub(end, start)) < (time * 1000));
+}
+
+void atomic_sect_run(void *data)
+{
+ unsigned long flags;
+
+ if (!strcmp(atomic_mode, "irq")) {
+ local_irq_save(flags);
+ busy_wait(atomic_time);
+ local_irq_restore(flags);
+ } else if (!strcmp(atomic_mode, "preempt")) {
+ preempt_disable();
+ busy_wait(atomic_time);
+ preempt_enable();
+ }
+ do_exit(0);
+}
+
+
+static int __init atomic_sect_init(void)
+{
+ char task_name[50];
+ struct task_struct *test_task;
+
+ sprintf(task_name, "%s dis test", atomic_mode);
+
+ test_task = kthread_run((void*)atomic_sect_run, NULL, task_name);
+ if (IS_ERR(test_task)) {
+ return -1;
+ }
+
+ return 0;
+}
+
+static void __exit atomic_sect_exit(void)
+{
+ return 0;
+}
+
+module_init(atomic_sect_init)
+module_exit(atomic_sect_exit)
+MODULE_LICENSE("GPL");
--
2.17.0.441.gb46fe60e1d-goog


2018-05-18 02:00:46

by Joel Fernandes

[permalink] [raw]
Subject: [PATCH 2/2] kselftests: ftrace: Add tests for the preemptoff and irqsoff tracers

From: "Joel Fernandes (Google)" <[email protected]>

Here we add unit tests for the preemptoff and irqsoff tracer by using a
kernel module introduced previously to trigger atomic sections in the
kernel.

Cc: Steven Rostedt <[email protected]>
Cc: Peter Zilstra <[email protected]>
Cc: Ingo Molnar <[email protected]>
Cc: Mathieu Desnoyers <[email protected]>
Cc: Tom Zanussi <[email protected]>
Cc: Namhyung Kim <[email protected]>
Cc: Thomas Glexiner <[email protected]>
Cc: Boqun Feng <[email protected]>
Cc: Paul McKenney <[email protected]>
Cc: Masami Hiramatsu <[email protected]>
Cc: Todd Kjos <[email protected]>
Cc: Erick Reyes <[email protected]>
Cc: Julia Cartwright <[email protected]>
Cc: [email protected]
Signed-off-by: Joel Fernandes (Google) <[email protected]>
---
tools/testing/selftests/ftrace/config | 3 +
.../test.d/preemptirq/irqsoff_tracer.tc | 74 +++++++++++++++++++
2 files changed, 77 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/preemptirq/irqsoff_tracer.tc

diff --git a/tools/testing/selftests/ftrace/config b/tools/testing/selftests/ftrace/config
index b01924c71c09..29588b328345 100644
--- a/tools/testing/selftests/ftrace/config
+++ b/tools/testing/selftests/ftrace/config
@@ -4,3 +4,6 @@ CONFIG_FUNCTION_PROFILER=y
CONFIG_TRACER_SNAPSHOT=y
CONFIG_STACK_TRACER=y
CONFIG_HIST_TRIGGERS=y
+CONFIG_PREEMPT_TRACER=y
+CONFIG_IRQSOFF_TRACER=y
+CONFIG_TEST_ATOMIC_SECTIONS=m
diff --git a/tools/testing/selftests/ftrace/test.d/preemptirq/irqsoff_tracer.tc b/tools/testing/selftests/ftrace/test.d/preemptirq/irqsoff_tracer.tc
new file mode 100644
index 000000000000..b76d781c5645
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/preemptirq/irqsoff_tracer.tc
@@ -0,0 +1,74 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: test for the preemptirqsoff tracer
+
+MOD=test_atomic_sections
+
+fail() {
+ reset_tracer
+ rmmod $MOD || true
+ exit_fail
+}
+
+unsup() { #msg
+ reset_tracer
+ rmmod $MOD || true
+ echo $1
+ exit_unsupported
+}
+
+modprobe $MOD || unsup "$MOD module not available"
+rmmod $MOD
+
+grep "preemptoff" available_tracers || unsup "preemptoff tracer not enabled"
+grep "irqsoff" available_tracers || unsup "irqsoff tracer not enabled"
+
+reset_tracer
+
+# Simulate preemptoff section for half a second couple of times
+echo preemptoff > current_tracer
+sleep 1
+modprobe test_atomic_sections atomic_mode=preempt atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+modprobe test_atomic_sections atomic_mode=preempt atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+modprobe test_atomic_sections atomic_mode=preempt atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+
+cat trace
+
+# Confirm which tracer
+grep "tracer: preemptoff" trace || fail
+
+# Check the end of the section
+egrep "5.....us : <stack trace>" trace || fail
+
+# Check for 500ms of latency
+egrep "latency: 5..... us" trace || fail
+
+reset_tracer
+
+# Simulate irqsoff section for half a second couple of times
+echo irqsoff > current_tracer
+sleep 1
+modprobe test_atomic_sections atomic_mode=irq atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+modprobe test_atomic_sections atomic_mode=irq atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+modprobe test_atomic_sections atomic_mode=irq atomic_time=500000 || fail
+rmmod test_atomic_sections || fail
+
+cat trace
+
+# Confirm which tracer
+grep "tracer: irqsoff" trace || fail
+
+# Check the end of the section
+egrep "5.....us : <stack trace>" trace || fail
+
+# Check for 500ms of latency
+egrep "latency: 5..... us" trace || fail
+
+reset_tracer
+exit 0
+
--
2.17.0.441.gb46fe60e1d-goog


2018-05-18 21:10:22

by Andy Shevchenko

[permalink] [raw]
Subject: Re: [PATCH 1/2] lib: Add module to simulate atomic sections for testing {preempt,irqs}off tracers

On Fri, May 18, 2018 at 4:59 AM, Joel Fernandes <[email protected]> wrote:
> From: "Joel Fernandes (Google)" <[email protected]>
>
> In this patch we introduce a test module for simulating a long atomic
> section in the kernel which the preemptoff or irqsoff tracers can
> detect. This module is to be used only for test purposes and is default
> disabled.
>
> Following is the expected output (only briefly shown) that can be parsed
> to verify that the tracers are working correctly. We will use this from
> the kselftests in future patches.

> +config TEST_ATOMIC_SECTIONS
> + tristate "Simulate atomic sections for tracers to detect"

> + default n

n _is_ default default.

> +/*

SPDX?

> + */

> +#include <linux/kernel.h>
> +#include <linux/module.h>
> +#include <linux/ktime.h>
> +#include <linux/irq.h>
> +#include <linux/printk.h>
> +#include <linux/interrupt.h>
> +#include <linux/delay.h>
> +#include <linux/string.h>
> +#include <linux/kthread.h>

Perhaps keep in order?

> +
> +static int atomic_time = 100;
> +static char atomic_mode[10] = "irq";
> +
> +module_param_named(atomic_time, atomic_time, int, S_IRUGO);
> +module_param_string(atomic_mode, atomic_mode, 10, S_IRUGO);
> +MODULE_PARM_DESC(atomic_time, "Period in microseconds (100 uS default)");
> +MODULE_PARM_DESC(atomic_mode, "Mode of the test such as preempt or irq (default irq)");

> +
> +

Extra blank line.

> +static int __init atomic_sect_init(void)
> +{
> + char task_name[50];
> + struct task_struct *test_task;
> +

> + sprintf(task_name, "%s dis test", atomic_mode);

Just to be protective from dumb user.

snprintf();

> +
> + test_task = kthread_run((void*)atomic_sect_run, NULL, task_name);
> + if (IS_ERR(test_task)) {

> + return -1;

return PTR_ERR() ?

> + }
> +
> + return 0;
> +}



--
With Best Regards,
Andy Shevchenko

2018-05-18 22:59:10

by Joel Fernandes

[permalink] [raw]
Subject: Re: [PATCH 1/2] lib: Add module to simulate atomic sections for testing {preempt,irqs}off tracers

On Sat, May 19, 2018 at 12:09:46AM +0300, Andy Shevchenko wrote:
> On Fri, May 18, 2018 at 4:59 AM, Joel Fernandes <[email protected]> wrote:
> > From: "Joel Fernandes (Google)" <[email protected]>
> >
> > In this patch we introduce a test module for simulating a long atomic
> > section in the kernel which the preemptoff or irqsoff tracers can
> > detect. This module is to be used only for test purposes and is default
> > disabled.
> >
> > Following is the expected output (only briefly shown) that can be parsed
> > to verify that the tracers are working correctly. We will use this from
> > the kselftests in future patches.
>
> > +config TEST_ATOMIC_SECTIONS
> > + tristate "Simulate atomic sections for tracers to detect"
>
> > + default n
>
> n _is_ default default.

I would rather be explicit, several other TEST configs also mention it. Is it
a strong desire to drop off default n?

> > +/*
>
> SPDX?

Ok, will add.

>
> > + */
>
> > +#include <linux/kernel.h>
> > +#include <linux/module.h>
> > +#include <linux/ktime.h>
> > +#include <linux/irq.h>
> > +#include <linux/printk.h>
> > +#include <linux/interrupt.h>
> > +#include <linux/delay.h>
> > +#include <linux/string.h>
> > +#include <linux/kthread.h>
>
> Perhaps keep in order?

Sure.

> > +
> > +static int atomic_time = 100;
> > +static char atomic_mode[10] = "irq";
> > +
> > +module_param_named(atomic_time, atomic_time, int, S_IRUGO);
> > +module_param_string(atomic_mode, atomic_mode, 10, S_IRUGO);
> > +MODULE_PARM_DESC(atomic_time, "Period in microseconds (100 uS default)");
> > +MODULE_PARM_DESC(atomic_mode, "Mode of the test such as preempt or irq (default irq)");
>
> > +
> > +
>
> Extra blank line.

Fixed

> > +static int __init atomic_sect_init(void)
> > +{
> > + char task_name[50];
> > + struct task_struct *test_task;
> > +
>
> > + sprintf(task_name, "%s dis test", atomic_mode);
>
> Just to be protective from dumb user.
>
> snprintf();
>

Done.

> > +
> > + test_task = kthread_run((void*)atomic_sect_run, NULL, task_name);
> > + if (IS_ERR(test_task)) {
>
> > + return -1;
>
> return PTR_ERR() ?

Sure, will do. Thanks for the review!

- Joel


2018-05-19 18:30:31

by Andy Shevchenko

[permalink] [raw]
Subject: Re: [PATCH 1/2] lib: Add module to simulate atomic sections for testing {preempt,irqs}off tracers

On Sat, May 19, 2018 at 1:58 AM, Joel Fernandes <[email protected]> wrote:
> On Sat, May 19, 2018 at 12:09:46AM +0300, Andy Shevchenko wrote:
>> On Fri, May 18, 2018 at 4:59 AM, Joel Fernandes <[email protected]> wrote:

>> > + default n
>>
>> n _is_ default default.
>
> I would rather be explicit, several other TEST configs also mention it. Is it
> a strong desire to drop off default n?

I guess so, it comes from Linus. See, for example, commit
0192f17529fa clean up x86 platform driver default values

--
With Best Regards,
Andy Shevchenko

2018-05-21 00:32:08

by kernel test robot

[permalink] [raw]
Subject: Re: [PATCH 1/2] lib: Add module to simulate atomic sections for testing {preempt,irqs}off tracers

Hi Joel,

Thank you for the patch! Perhaps something to improve:

[auto build test WARNING on linus/master]
[also build test WARNING on v4.17-rc6 next-20180517]
[if your patch is applied to the wrong git tree, please drop us a note to help improve the system]

url: https://github.com/0day-ci/linux/commits/Joel-Fernandes/Tests-for-preemptoff-and-irqsoff-tracers/20180521-064835
config: sparc64-allyesconfig (attached as .config)
compiler: sparc64-linux-gnu-gcc (Debian 7.2.0-11) 7.2.0
reproduce:
wget https://raw.githubusercontent.com/intel/lkp-tests/master/sbin/make.cross -O ~/bin/make.cross
chmod +x ~/bin/make.cross
# save the attached .config to linux build tree
make.cross ARCH=sparc64

All warnings (new ones prefixed by >>):

lib/test_atomic_sections.c: In function 'atomic_sect_exit':
>> lib/test_atomic_sections.c:75:9: warning: 'return' with a value, in function returning void
return 0;
^
lib/test_atomic_sections.c:73:20: note: declared here
static void __exit atomic_sect_exit(void)
^~~~~~~~~~~~~~~~

vim +/return +75 lib/test_atomic_sections.c

72
73 static void __exit atomic_sect_exit(void)
74 {
> 75 return 0;
76 }
77

---
0-DAY kernel test infrastructure Open Source Technology Center
https://lists.01.org/pipermail/kbuild-all Intel Corporation


Attachments:
(No filename) (1.41 kB)
.config.gz (52.02 kB)
Download all attachments